# -*- coding: utf-8 -*- 
'''
Praktikum 14, lahendused
Viimati uuendatud 8.12.2024.

Kui sul on kõrge resolutsiooniga ekraan sisesta IPythoni konsooli:
%config InlineBackend.figure_format='retina' 
'''

#%% ül 1
import numpy as np

a = np.arange(1, 31, 1).reshape(6, 5)
print(a)

print('\nKüsitud piirkond:\n')
print(a[2:4, 0:2])  # Indeksid 4 ja 2 pole kaasa arvatud.


#%% ül 2
import numpy as np

a = np.arange(1, 31).reshape(6, 5)
print(a)

print('\nKüsitud piirkond:\n')
print(a[[0, 1, 2, 3], [1, 2, 3, 4]])


#%% ül 2, teine lahendus.
import numpy as np

a = np.arange(1, 31).reshape(6, 5)
print(a.diagonal(1))


#%% ül 2, kolmas lahendus.
import numpy as np

a = np.arange(1, 31).reshape(6, 5)
print(np.diagonal(a, 1))


#%% ül 3
import numpy as np

a = np.arange(1, 16, 0.5).reshape(6, 5)
print(a)

print('\nKüsitud piirkond:\n')
print(a[[0, 4, 5], 3:])  # Read nopin, veerge spannin.


#%% ül 4
import numpy as np

a = np.arange(1, 16, 0.5).reshape(6, 5)

print(a.mean(axis=1))  # Ridade elemendid, itereerib veerge.
print(a.mean(axis=0))  # Veergude elemendid, itereerib ridu. 
print(a.mean(axis=None))


#%% ül 4, kasutades funktsioone (teadmiseks).
import numpy as np

a = np.arange(1, 16, 0.5).reshape(6, 5)

print(np.mean(a, axis=1))  # Ridade elemendid, itereerib veerge.
print(np.mean(a, axis=0))  # Veergude elemendid, itereerib ridu.
print(np.mean(a, axis=None))  # np.mean(a)


#%% ül 5
import numpy as np

a = np.arange(1, 16, 0.5).reshape(6, 5)

print(a.prod(axis=1))  # Ridade elemendid, itereerib veerge.
print(a.prod(axis=0))  # Veergude elemendid, itereerib ridu.
print(a.prod(axis=None))  # a.prod()


#%% ül 5, kasutades funktsioone (teadmiseks).
import numpy as np

a = np.arange(1, 16, 0.5).reshape(6, 5)

print(np.prod(a, axis=1))  # Ridade elemendid, itereerib veerge.
print(np.prod(a, axis=0))  # Veergude elemendid, itereerib ridu.
print(np.prod(a, axis=None))  # np.prod(a)


#%% ül 6
import numpy as np

a = np.arange(1, 16, 0.5).reshape(6, 5)
print(a)

print('\nPaarisarvulised elemendid:\n')
print(a%2 == 0)  # Elementhaaval.


#%% ül 7
import numpy as np

a = np.array([[1, 2],
              [1, 3]])

b = np.array([1, 2])

print(a.dot(a).dot(b))
print()

print(a @ a @ b)
print()

print(np.linalg.matrix_power(a, 2).dot(b))


#%% ül 7, teine lahendus.
import numpy as np

a = np.array([[1, 2],
              [1, 3]])

b = np.array([[1],
              [2]])  # Kui oled pedant.

print(a.dot(a).dot(b))
print()

print(a @ a @ b)
print()

print(np.linalg.matrix_power(a, 2).dot(b))


#%% ül 8
import numpy as np
from scipy import linalg

# Süsteemi koefitsentide maatriks:
A = np.array([[1, 3, 1],
              [2, 5, 7],
              [3, 6, 8]])

# Lahendamine:
lahend = linalg.solve(A, [50, 140, 170])  
print('Lahed =', lahend)

# Kontroll:
lahend_kontroll = A.dot(lahend)
print(lahend_kontroll)


#%% ül 8, teine lahend.
import numpy as np
from scipy import linalg

# Süsteemi koefitsentide maatriks:
A = np.array([[1, 3, 1],
              [2, 5, 7],
              [3, 6, 8]])

vec = np.array([50, 140, 170])
# Lahendamine:
lahend = linalg.solve(A, vec)  
print('Lahed =', lahend)

# Kontroll:
lahend_kontroll = A.dot(lahend)
print(lahend_kontroll)


#%% ül 8, kolmas lahend.
import numpy as np
from scipy import linalg

# Süsteemi koefitsentide maatriks:
A = np.array([[1, 3, 1],
              [2, 5, 7],
              [3, 6, 8]])

vec = np.array([50, 140, 170]).T
# Lahendamine:
lahend = linalg.solve(A, vec)  
print('Lahed =', lahend)

# Kontroll:
lahend_kontroll = A.dot(lahend)
print(lahend_kontroll)


#%% ül 8, neljas lahend.
import numpy as np
from scipy import linalg

# Süsteemi koefitsentide maatriks:
A = np.array([[1, 3, 1],
              [2, 5, 7],
              [3, 6, 8]])

vec = np.array([[50],
                [140],
                [170]])
# Lahendamine:
lahend = linalg.solve(A, vec)  
print('Lahed =', lahend)

# Kontroll:
lahend_kontroll = A.dot(lahend)
print(lahend_kontroll)


#%% ül 9
import matplotlib.pyplot as plt
import numpy as np
# Kui sul on kõrge resolutsiooniga ekraan sisesta IPythoni konsooli:
# %config InlineBackend.figure_format='retina'

t_max = 10
f_0 = 1

t = np.linspace(0, t_max, 500)  # Pead suurendama punktide arvu. Vaikimisi kõigest 50.
f = np.sqrt(t) + np.sin(2 * np.pi * f_0 * t)

plt.plot(t, f)

plt.xlabel('Aeg $t$ [s]')
plt.ylabel('Funktsioon $f(t)$ [m]')
#plt.savefig("test.pdf")
plt.show()


#%% ül 10
import matplotlib.pyplot as plt
import numpy as np

f = 1        # [Hz] Sagedus.
alpha = 0.1  # [1/s = Hz] Sumbuvus.

t = np.linspace(0, 30, 1000)

plt.plot(t, np.exp(-alpha * t) * np.cos(2 * f * np.pi * t))
plt.xlabel('Aeg [s]')
plt.ylabel('Amplituud [m]')
#plt.savefig('test.pdf')
plt.show()


#%% ül 11
import matplotlib.pyplot as plt
import numpy as np

f = 1        # [Hz] Sagedus.
alpha = 0.1  # [1/s = Hz] Sumbuvus.

t = np.linspace(0, 30, 1000)

plt.plot(t, np.exp(-alpha * t) * np.cos(2 * f * np.pi * t))
plt.plot(t, np.exp(-alpha * t))
plt.plot(t, -np.exp(-alpha * t))
plt.xlabel('Aeg [s]')
plt.ylabel('Amplituud [m]')
#plt.savefig('test.pdf')
plt.show()


#%% ül 11, teine lahend.
import matplotlib.pyplot as plt
import numpy as np

f = 1        # [Hz] Sagedus.
alpha = 0.1  # [1/s = Hz] Sumbuvus.

t = np.linspace(0, 30, 1000)

signal = np.exp(-alpha * t) * np.cos(2 * f * np.pi * t)
mp = np.exp(-alpha * t)
mm = -mp

plt.plot(t, signal)
plt.plot(t, mp)
plt.plot(t, mm)
plt.xlabel('Aeg [s]')
plt.ylabel('Amplituud [m]')
#plt.savefig('test.pdf')
plt.show()


#%% ül 12
import matplotlib.pyplot as plt
import numpy as np

f0 = 1  # [Hz] Sagedus.

t = np.linspace(0, 4, 600)

plt.plot(t, np.cos(2 * f0 * np.pi * t**2))
plt.plot(t, 0.5 * np.ones(t.size))
plt.plot([0.42, 0.42], [-1, 1])  # Joon kahe punkti vahel, tavaline list.

plt.xlabel('Aeg [s]')
plt.ylabel('Amplituud [m]')
#plt.savefig('test.pdf')
plt.show()


#%% ül 12, teine lahendus
import matplotlib.pyplot as plt
import numpy as np

f0 = 1  # [Hz] Sagedus.

t = np.linspace(0, 4, 600)

plt.plot(t, np.cos(2 * f0 * np.pi * t**2))
plt.axhline(y=0.5, c='k')
plt.axvline(x=0.42, c='r')
#plt.axhline(0.5, c='k')
#plt.axvline(0.42, c='r')

plt.xlabel('Aeg [s]')
plt.ylabel('Amplituud [m]')
#plt.savefig('test.pdf')
plt.show()


#%% ül 13
import matplotlib.pyplot as plt
import numpy as np

x, y = np.loadtxt(
    'data_L14.txt',
    delimiter='\t',
    skiprows=0,
    usecols=(0, 1),
    unpack=True
    )
    
plt.plot(x, y)

plt.xlabel('x')
plt.ylabel('y')
#plt.savefig('test.pdf')
plt.show()


#%% ül 14
import matplotlib.pyplot as plt
import numpy as np

r = 1

x = np.linspace(-r, r, 500)  # Lisa piisavalt punkte.
y = np.sqrt(r**2 - x**2)

plt.plot(x, y)  # Positiivne pool.
plt.plot(x, -y)  # Negatiivne pool.

plt.xlabel('Argument $x$')
plt.ylabel('Funktsioon $y_{\pm}(x)$')
#plt.savefig("test.pdf")
plt.show()


#%% ül 15
import matplotlib.pyplot as plt
import numpy as np

r = 1  # Raadius.

# Pool ringjoonest:
x = np.linspace(-r, r, 600)  # Lisa piisavalt punkte.
y = np.sqrt(r**2 - x**2)

# Pool ruutu:
def nth_root(x, n):
    nth_root = x**(1 / n)
    return nth_root

# Juht n = 4.
n = 4
yn = nth_root(r**n - x**n, n)

# Juht n = 400.
n = 400
y_ruut = nth_root(r**n - x**n, n)


plt.plot(x, y)
plt.plot(x, -y)

plt.plot(x, yn)
plt.plot(x, -yn)

plt.plot(x, y_ruut)
plt.plot(x, -y_ruut)

plt.xlabel('Argument $x$')
plt.ylabel('Funktsioon $y_{\pm}(x)$')
#plt.savefig("test.pdf")
plt.show()



#%% ül 16, osa 1.
import matplotlib.pyplot as plt

r = 3.7
f = lambda x: r*x*(1 - x)

def iterate_func(func, x):  # Itereerib üle etteantud funktsiooni.
   while True:
       yield x
       x = func(x)  # Leiab järgmise x väärtuse.

x = iterate_func(f, 0.6)  # Loome iteraator.

lst = []
for _ in range(51):
   lst.append(next(x))

plt.plot(lst, '.-')

plt.xlabel('Indeks $n$')
plt.ylabel('Iteraat $x_n$')
#plt.savefig("test.pdf")
plt.show()


#%% ül 16, osa 2.
import matplotlib.pyplot as plt
import numpy as np

x = np.empty(51)  # Massiivi loomine.

r = 3.7
x[0] = 0.6

for n in range(50):
    x[n+1] = r * x[n] * (1 - x[n])

plt.plot(x, '.-')

plt.xlabel('Indeks $n$')
plt.ylabel('Iteraat $x_n$')
#plt.savefig("test.pdf")
plt.show()


#%% ül 17
import matplotlib.pyplot as plt
import numpy as np

n = 25000  # Iteraatide arv.

x = np.empty(n + 1)
y = np.empty(n + 1)

x[0] = -0.1
y[0] = 0.0

for i in np.arange(n):  # Parem/kiirem kui Pythoni range.
    x[i+1] = 1 - y[i] + np.abs(x[i])
    y[i+1] = x[i]

plt.plot(x, y, ',')  # Originaal.

plt.xticks([])
plt.yticks([])
plt.title('Häid jõule!')
#plt.axis('off')  # Koledam.
#plt.savefig('test.pdf')
plt.show()


#%% ül 17, teine lahend.
import matplotlib.pyplot as plt
import numpy as np

n = 25000
x0 = -0.1  # -0.3
y0 = 0.0

x = np.empty(n)
y = np.empty(n)

for i in np.arange(n):  # Parem/kiirem kui Pythoni range.
    if i == 0:
        x[i] = 1 - y0 + np.abs(x0)
        y[i] = x0
    else:
        x[i] = 1 - y[i-1] + np.abs(x[i-1])
        y[i] = x[i-1]

plt.plot(x, y, ',')  # Originaal.

plt.xticks([])
plt.yticks([])
plt.title('Häid jõule!')
#plt.savefig('test.pdf')
plt.show()


#%% ül 17, peegelpilt y-telje sihis lisab ilu.
import matplotlib.pyplot as plt
import numpy as np

n = 25000  # Iteraatide arv.

x = np.empty(n + 1)
y = np.empty(n + 1)

x[0] = -0.1
y[0] = 0.0

for i in np.arange(n):  # Parem/kiirem kui Pythoni range.
    x[i+1] = 1 - y[i] + np.abs(x[i])
    y[i+1] = x[i]

plt.plot(x, -y, ',')  # Originaal.

plt.xticks([])
plt.yticks([])
plt.title('Häid jõule!')
#plt.savefig('test.pdf')
plt.show()


#%% ül 18
import matplotlib.pyplot as plt
import numpy as np

f = 1        # [Hz] Sagedus.
alpha = 0.1  # [1/s = Hz] Sumbuvustegur.
beta = 0.015

t = np.linspace(0, 30, 500)

plt.rcParams.update({'figure.figsize': (14, 5)})  # Suuruse muutmine (Nädal 15).
#plt.reParams['figure.figsize'] = (14, 5)  # Nii saab ka.

plt.subplot(1, 3, 1)
plt.plot(t, np.exp(-alpha * t) * np.cos(2 * f * np.pi * t))
plt.xlabel('Aeg [s]')
plt.ylabel('Amplituud [m]')

plt.subplot(1, 3, 2)
plt.plot(t, np.exp(-beta*(t - 15)**2) * np.cos(2 * f * np.pi * t))
plt.xlabel('Aeg [s]')
plt.ylabel('Amplituud [m]')

plt.subplot(1, 3, 3)
plt.plot(t, np.exp(alpha * t) * np.cos(2 * f * np.pi * t)/20)
plt.xlabel('Aeg [s]')
plt.ylabel('Amplituud [m]')

#plt.savefig('test.pdf')
plt.show()

# Alglähtestan graafiku suuruse:
plt.rcParams.update(plt.rcParamsDefault)


#%% ül 19

def ava_uks(uks):
    avatus = uks['link_all'] and uks['voti_sobib'] and uks['voti_keerab']
    print(f'Avatus: {uks} --> {avatus}')
    if avatus:
        return True
    
    if uks['link_all']:
        uks['link_all'] = False
        if uks['voti_sobib']:
            uks['voti_sobib'] = False
            if uks['voti_keerab']:
                uks['voti_sobib'] = True
            else:
                uks['voti_keerab'] = True
        else:
            uks['voti_sobib'] = True
    else:
        uks['link_all'] = True
    
    return ava_uks(uks)

uksolek = dict(link_all=False, voti_sobib=False, voti_keerab=False)  # Sisend.

print('Lahend -->', ava_uks(uksolek))












